! 
! File:          Ordering_IntOrderTest_Impl.F90
! Symbol:        Ordering.IntOrderTest-v0.1
! Symbol Type:   class
! Babel Version: 0.8.6
! Description:   Server-side implementation for Ordering.IntOrderTest
! 
! WARNING: Automatically generated; only changes within splicers preserved
! 
! babel-version = 0.8.6
! 


! 
! Symbol "Ordering.IntOrderTest" (version 0.1)
! 
! This class provides methods to verify that the array ordering
! capabilities work for arrays of int.
! 


#include "Ordering_IntOrderTest_fAbbrev.h"
#include "SIDL_BaseInterface_fAbbrev.h"
#include "SIDL_BaseClass_fAbbrev.h"
#include "SIDL_ClassInfo_fAbbrev.h"
#include "SIDL_int_fAbbrev.h"
! DO-NOT-DELETE splicer.begin(_miscellaneous_code_start)
integer(selected_int_kind(9)) function iFunc(ind, dim)
  implicit none
  integer(selected_int_kind(9)) :: dim
  integer(selected_int_kind(9)), dimension(dim), intent(in) :: ind
  integer(selected_int_kind(9)) :: result, i
  result = 0
  do i=1, dim
     result = result + i * ind(i)
  enddo
  ifunc = result
end function iFunc

logical function incIndex(ind, A, dim)
  use SIDL_int_array
  implicit none
  integer(selected_int_kind(9)) :: dim
  integer(selected_int_kind(9)), dimension(dim) :: ind
  integer(selected_int_kind(9)) :: i, up, low
  type(SIDL_int_a), intent(in) :: A
  incIndex = .false.
  i = 1
  do while (i .le. dim .and. .not. incIndex) 
     up = upper(A, i - 1)
     ind(i) = ind(i) + 1
     if (ind(i) .gt. up) then
        low = lower(A, i - 1)
        ind(i) = low
        i = i + 1
     else
        incIndex = .true.
     endif
  enddo
end function incIndex

logical function isIMatrix(A)
  use SIDL_int_array
  implicit none
  type(SIDL_int_a), intent(in) :: A
  integer(selected_int_kind(9)) :: dim, i, up
  integer(selected_int_kind(9)), dimension(16) :: cindex
  integer(selected_int_kind(9)) :: iFunc, elem
  logical incIndex
  dim = dimen(A)
  isIMatrix = .false.
  if ((dim .le. 16) .and. (dim .gt. 0)) then
     do i = 1, dim
        cindex(i) = lower(A, i - 1)
        up = upper(A, i - 1)
        if (cindex(i) .gt. up) then
           isIMatrix = .true.
        endif
     enddo
     if (.not. isIMatrix) then
        cindex(1) = cindex(1) - 1
        isIMatrix = .true.
        do while (incIndex(cindex, A, dim) .and. isIMatrix)
           call get(A, cindex, elem)
           if (iFunc(cindex, dim) .ne. elem) then
              isIMatrix = .false.
           endif
        enddo
     endif
  endif
end function isIMatrix

subroutine fillIMatrix(A)
  use SIDL_int_array
  implicit none
  type(SIDL_int_a) ::  A
  integer(selected_int_kind(9)) :: dim, i,  up, iFunc
  integer(selected_int_kind(9)), dimension(16) :: cindex
  logical incIndex
  if (not_null(A)) then
     dim = dimen(A)
     if ((dim .le. 16) .and. (dim .gt. 0)) then
        do i = 1, dim
           cindex(i) = lower(A, i - 1)
           up = upper(A, i - 1)
           if (cindex(i) .gt. up) then
              return
           endif
        enddo
        cindex(1) = cindex(1) - 1
        do while (incIndex(cindex, A, dim))
           call set(A, cindex, iFunc(cindex, dim))
        enddo
     endif
  endif
end subroutine fillIMatrix
! DO-NOT-DELETE splicer.end(_miscellaneous_code_start)




! 
! Class constructor called when the class is created.
! 

recursive subroutine Ordering_IntOrderTest__ctor_mi(self)
  use Ordering_IntOrderTest
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest._ctor.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest._ctor.use)
  implicit none
  type(Ordering_IntOrderTest_t) :: self

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest._ctor)
! Insert the implementation here...
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest._ctor)
end subroutine Ordering_IntOrderTest__ctor_mi


! 
! Class destructor called when the class is deleted.
! 

recursive subroutine Ordering_IntOrderTest__dtor_mi(self)
  use Ordering_IntOrderTest
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest._dtor.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest._dtor.use)
  implicit none
  type(Ordering_IntOrderTest_t) :: self

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest._dtor)
! Insert the implementation here...
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest._dtor)
end subroutine Ordering_IntOrderTest__dtor_mi


! 
! Create a column-major matrix satisfying condition I.
! 

recursive subroutine makeColumnIMatrixz5ybfavnz3i_mi(size, useCreateCol,       &
  retval)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.makeColumnIMatrix.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.makeColumnIMatrix.use)
  implicit none
  integer (selected_int_kind(9)) :: size
  logical :: useCreateCol
  type(SIDL_int_a) :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.makeColumnIMatrix)
  if (useCreateCol) then
     call create2dCol(size, size, retval)
  else
     call create2dRow(size, size, retval)
  endif
  call fillIMatrix(retval)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.makeColumnIMatrix)
end subroutine makeColumnIMatrixz5ybfavnz3i_mi


! 
! Create a row-major matrix satisfying condition I.
! 

recursive subroutine Int_makeRowIMatrix8h06e37u6x_mi(size, useCreateRow,       &
  retval)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.makeRowIMatrix.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.makeRowIMatrix.use)
  implicit none
  integer (selected_int_kind(9)) :: size
  logical :: useCreateRow
  type(SIDL_int_a) :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.makeRowIMatrix)
  if (useCreateRow) then
     call create2dRow(size, size, retval)
  else
     call create2dCol(size, size, retval)
  endif
  call fillIMatrix(retval)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.makeRowIMatrix)
end subroutine Int_makeRowIMatrix8h06e37u6x_mi


! 
! Create a 4-D matrix satisfying condition I.  Each dimension has
! size elements numbers 0 through size-1.
! 

recursive subroutine IntOrd_makeIMatrixs68ixk4nld_mi(size, useCreateColumn,    &
  retval)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.makeIMatrix.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.makeIMatrix.use)
  implicit none
  integer (selected_int_kind(9)) :: size
  logical :: useCreateColumn
  type(SIDL_int_a) :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.makeIMatrix)
  integer(selected_int_kind(9)) low(4), up(4), i
  do i = 1, 4
     low(i) = 0
     up(i) = size - 1
  enddo
  if (useCreateColumn) then
     call createCol(low, up, retval)
  else
     call createRow(low, up, retval)
  endif
  call fillIMatrix(retval)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.makeIMatrix)
end subroutine IntOrd_makeIMatrixs68ixk4nld_mi


! 
! Create a column-major matrix satisfying condition I.
! 

recursive subroutine createColumnIMatrij98n1gtwcu_mi(size, useCreateCol,       &
  result)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.createColumnIMatrix.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.createColumnIMatrix.use)
  implicit none
  integer (selected_int_kind(9)) :: size
  logical :: useCreateCol
  type(SIDL_int_a) :: result

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.createColumnIMatrix)
  if (useCreateCol) then
     call makeColumnIMatrix(size, .true., result)
  else
     call makeRowIMatrix(size, .true., result)
  endif
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.createColumnIMatrix)
end subroutine createColumnIMatrij98n1gtwcu_mi


! 
! Create a row-major matrix satisfying condition I.
! 

recursive subroutine I_createRowIMatrixq_lpgbci6l_mi(size, useCreateRow,       &
  result)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.createRowIMatrix.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.createRowIMatrix.use)
  implicit none
  integer (selected_int_kind(9)) :: size
  logical :: useCreateRow
  type(SIDL_int_a) :: result

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.createRowIMatrix)
  if (useCreateRow) then
     call makeRowIMatrix(size, .true., result)
  else
     call makeColumnIMatrix(size, .true., result)
  endif
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.createRowIMatrix)
end subroutine I_createRowIMatrixq_lpgbci6l_mi


! 
! Make sure an array is column-major.  No changes to the dimension or
! values in a are made.
! 

recursive subroutine IntOr_ensureColumno2tek0_o3o_mi(a)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.ensureColumn.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.ensureColumn.use)
  implicit none
  type(SIDL_int_a) :: a

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.ensureColumn)
!     no action required
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.ensureColumn)
end subroutine IntOr_ensureColumno2tek0_o3o_mi


! 
! Make sure an array is row-major.  No changes to the dimension or
! values in a are made.
! 

recursive subroutine IntOrder_ensureRow2xbnpv1nvt_mi(a)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.ensureRow.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.ensureRow.use)
  implicit none
  type(SIDL_int_a) :: a

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.ensureRow)
!     no action required
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.ensureRow)
end subroutine IntOrder_ensureRow2xbnpv1nvt_mi


! 
!  Return <code>true</code> iff the implementation sees
!  an incoming array satisfying condition I.
! 

recursive subroutine IntOr_isIMatrixOne3gwlgypfcv_mi(A, retval)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isIMatrixOne.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isIMatrixOne.use)
  implicit none
  type(SIDL_int_a) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isIMatrixOne)
  logical isIMatrix
  retval = isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isIMatrixOne)
end subroutine IntOr_isIMatrixOne3gwlgypfcv_mi


! 
! Return <code>true</code> iff the implementation sees
! an incoming column-major array satisfying condition I.
! 

recursive subroutine isColumnIMatrixOned9rdelopb9_mi(A, retval)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isColumnIMatrixOne.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isColumnIMatrixOne.use)
  implicit none
  type(SIDL_int_a) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isColumnIMatrixOne)
  logical acol, isIMatrix
  acol = isColumnOrder(A)
  retval = acol .and. isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isColumnIMatrixOne)
end subroutine isColumnIMatrixOned9rdelopb9_mi


! 
! Return <code>true</code> iff the implementation sees
! an incoming row-major array satisfying condition I.
! 

recursive subroutine In_isRowIMatrixOne607iplqtr5_mi(A, retval)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isRowIMatrixOne.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isRowIMatrixOne.use)
  implicit none
  type(SIDL_int_a) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isRowIMatrixOne)
  logical arow, isIMatrix
  arow = isRowOrder(A)
  retval = arow .and. isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isRowIMatrixOne)
end subroutine In_isRowIMatrixOne607iplqtr5_mi


! 
!  Return <code>true</code> iff the implementation sees
!  an incoming array satisfying condition I.
! 

recursive subroutine IntOr_isIMatrixTwogo7_eewh9w_mi(A, retval)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isIMatrixTwo.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isIMatrixTwo.use)
  implicit none
  type(SIDL_int_a) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isIMatrixTwo)
  logical isIMatrix
  retval = isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isIMatrixTwo)
end subroutine IntOr_isIMatrixTwogo7_eewh9w_mi


! 
! Return <code>true</code> iff the implementation sees
! an incoming column-major array satisfying condition I.
! 

recursive subroutine isColumnIMatrixTwo9neer9_rft_mi(A, retval)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isColumnIMatrixTwo.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isColumnIMatrixTwo.use)
  implicit none
  type(SIDL_int_a) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isColumnIMatrixTwo)
  logical acol, isIMatrix
  acol = isColumnOrder(A)
  retval = acol .and. isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isColumnIMatrixTwo)
end subroutine isColumnIMatrixTwo9neer9_rft_mi


! 
! Return <code>true</code> iff the implementation sees
! an incoming row-major array satisfying condition I.
! 

recursive subroutine In_isRowIMatrixTwoqo0guawv83_mi(A, retval)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isRowIMatrixTwo.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isRowIMatrixTwo.use)
  implicit none
  type(SIDL_int_a) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isRowIMatrixTwo)
  logical arow, isIMatrix
  arow = isRowOrder(A)
  retval = arow .and. isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isRowIMatrixTwo)
end subroutine In_isRowIMatrixTwoqo0guawv83_mi


! 
!  Return <code>true</code> iff the implementation sees
!  an incoming array satisfying condition I.
! 

recursive subroutine IntO_isIMatrixFourgf7n_6hyd2_mi(A, retval)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isIMatrixFour.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isIMatrixFour.use)
  implicit none
  type(SIDL_int_a) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isIMatrixFour)
  logical isIMatrix
  retval = isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isIMatrixFour)
end subroutine IntO_isIMatrixFourgf7n_6hyd2_mi


! 
! Return <code>true</code> iff the implementation sees
! an incoming column-major array satisfying condition I.
! 

recursive subroutine isColumnIMatrixFouunjqbwfb23_mi(A, retval)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isColumnIMatrixFour.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isColumnIMatrixFour.use)
  implicit none
  type(SIDL_int_a) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isColumnIMatrixFour)
  logical acol, isIMatrix
  acol = isColumnOrder(A)
  retval = acol .and. isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isColumnIMatrixFour)
end subroutine isColumnIMatrixFouunjqbwfb23_mi


! 
! Return <code>true</code> iff the implementation sees
! an incoming row-major array satisfying condition I.
! 

recursive subroutine I_isRowIMatrixFourfai8pehvh9_mi(A, retval)
  use Ordering_IntOrderTest
  use SIDL_int_array
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isRowIMatrixFour.use)
  ! Insert use statements here...
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isRowIMatrixFour.use)
  implicit none
  type(SIDL_int_a) :: A
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isRowIMatrixFour)
  logical arow, isIMatrix
  arow = isRowOrder(A)
  retval = arow .and. isIMatrix(A)
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isRowIMatrixFour)
end subroutine I_isRowIMatrixFourfai8pehvh9_mi


! 
! Return <code>true</code> iff the implementation of slice
! and smart copy is correct.
! 

recursive subroutine Int_isSliceWorkingf42w8d0h4b_mi(useCreateCol, retval)
  use Ordering_IntOrderTest
  use Ordering_IntOrderTest_impl
  ! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isSliceWorking.use)
  use SIDL_int_array
  ! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isSliceWorking.use)
  implicit none
  logical :: useCreateCol
  logical :: retval

! DO-NOT-DELETE splicer.begin(Ordering.IntOrderTest.isSliceWorking)
  integer(selected_int_kind(9)) :: maxDim, halfDim, ind(2), &
       astride(2), numElem(2)
  integer(selected_int_kind(9)) :: newIndex(2), dim, Aelem, &
       Belem, iFunc
  type(SIDL_int_a) :: A, B
  retval = .true.
  maxDim = 16
  halfDim = maxDim / 2
  astride(1) = 2
  astride(2) = 2
  numElem(1) = halfDim
  numElem(2) = halfDim
  ind(1) = 0
  ind(2) = 0
  newIndex(1) = 0
  newIndex(2) = 0
  call set_null(A)
  call set_null(B)
  if (useCreateCol) then
     call makeColumnIMatrix(maxDim, .false., A)
  else
     call makeRowIMatrix(maxDim, .false., A)
  endif
  call slice(A, 2, numElem, ind, astride, newIndex, B)
  if (is_null(B)) then 
     retval = .false.
     goto 100
  endif
  dim = dimen(B)
  if (dim .ne. 2) then
     retval = .false.
     goto 100
  endif

  do while (newIndex(2) .lt. halfDim)
     do while (newIndex(1) .lt. halfDim)
        call get(A, ind, Aelem)
        call get(B, newIndex, Belem)
        if ((Aelem .ne. Belem) .or.  Belem .ne. iFunc(ind, 2)) then
           retval = .false.
           goto 100
        endif
        newIndex(1) = newIndex(1) + 1
        ind(1) = ind(1) + 2
     enddo
     newIndex(2) = newIndex(2) + 1
     ind(2) = ind(2) + 2
  enddo

  ! CLEANUP AND RETURN
100 if (not_null(A)) then
     call deleteRef(A)
  endif
  if (not_null(B)) then
     call deleteRef(B)
  endif
! DO-NOT-DELETE splicer.end(Ordering.IntOrderTest.isSliceWorking)
end subroutine Int_isSliceWorkingf42w8d0h4b_mi


! DO-NOT-DELETE splicer.begin(_miscellaneous_code_end)
! Insert extra code here...
! DO-NOT-DELETE splicer.end(_miscellaneous_code_end)
